---
title: WebGLTransformFeedback
slug: Web/API/WebGLTransformFeedback
tags:
  - API
  - Interface
  - Reference
  - WebGL
  - WebGL2
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGLTransformFeedback</code></strong> interface is part of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL 2</a> API and enables transform feedback, which is the process of capturing primitives generated by vertex processing. It allows to preserve the post-transform rendering state of an object and resubmit this data multiple times.</p>

<p>When working with <code>WebGLTransformFeedback</code> objects, the following methods of the {{domxref("WebGL2RenderingContext")}} are useful:</p>

<ul>
 <li>{{domxref("WebGL2RenderingContext.createTransformFeedback()")}}</li>
 <li>{{domxref("WebGL2RenderingContext.deleteTransformFeedback()")}}</li>
 <li>{{domxref("WebGL2RenderingContext.isTransformFeedback()")}}</li>
 <li>{{domxref("WebGL2RenderingContext.bindTransformFeedback()")}}</li>
 <li>{{domxref("WebGL2RenderingContext.beginTransformFeedback()")}}</li>
 <li>{{domxref("WebGL2RenderingContext.endTransformFeedback()")}}</li>
 <li>{{domxref("WebGL2RenderingContext.pauseTransformFeedback()")}}</li>
 <li>{{domxref("WebGL2RenderingContext.resumeTransformFeedback()")}}</li>
 <li>{{domxref("WebGL2RenderingContext.transformFeedbackVaryings()")}}</li>
 <li>{{domxref("WebGL2RenderingContext.getTransformFeedbackVarying()")}}</li>
</ul>

<h2 id="Examples">Examples</h2>

<h3 id="Creating_a_WebGLTransformFeedback_object">Creating a <code>WebGLTransformFeedback</code> object</h3>

<p>in this example, <code>gl</code> must be a {{domxref("WebGL2RenderingContext")}}. <code>WebGLTransformFeedback</code> objects are not available in WebGL 1.</p>

<pre class="brush: js">var transformFeedback = gl.createTransformFeedback();</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL2', "#3.5", "WebGLTransformFeedback")}}</td>
   <td>{{Spec2('WebGL2')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGLTransformFeedback")}}</p>
